' Prozedur QFileDialog
' Version  1.0  10.07.2011.    Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka    homepage: http://www.gerhard-putschalka.

' Prozedur QFileDialog zur Dateiauswahl als Eingabe- oder Ausgabedatei
' entspricht ungefhr den Profanfunktionen @LoadFile$ und SaveFile$ mit den Unterschieden dass:
' - bei der Loadfunktion auch mehrere Eingabedateien ausgewhlt werden knnen
' - bei der Savefunktion beim Vorhandensein der gewhlten Datei entweder keine Meldung
'   oder ein Dialog angezeigt wird der ein Ersetzen oder Hinzufgen der neuen Daten erlaubt.

' zum Aufruf des FileDialoges sind 5 Parameter erforderlich:
'  1. "Load", "Save" oder "Save1" ("Load" erlaubt mehrfach Selektion)
'  2. der Dialoghandle (bzw. %Hwnd)
'  3. Filter welche Dateiarten auswhlbar sein sollen (Muster ist im Profan-LoadFile Dialog beschrieben)
'  4. Text fr die Dialog-Titelzeile
'  5. Handle einer Liste (in diese Liste werden die ausgewhlten Dateinamen gestellt)

'  Bei "Save" erfolgt keine Meldung. Nur ber den Rckgabewert ist erkennbar ob die Datei bereits 
'   existiert.

' Die Datei(en) werden in einer Liste (5. Parameter) aus der Prozedur bergeben.

' Rckgabewerte:
' -1 es wurde abgebrochen
'  0 die Datei existiert nicht (bei Save und Save1)
'  1 die Datei existiert (bei Load, Save und Save1) (bei Save1 erfolgt keine Meldung)
'  2 fr die existierende Datei wurde ersetzen ausgewhlt (nur Save1)
'  3 fr die existierende Datei wurde anhngen ausgewhlt (nur Save1)
'  4 fr die existierende Datei Abbruch ausgewhlt (nur Save1)

' Die Prozedur QFileDialog kann mit dem Programm QFileDialog.prf getestet werden.


Declare ofn#,Filter#,File#,QRet%
Def GetSave(1) ! "comdlg32","GetSaveFileNameA"
Def GetOpen(1) ! "comdlg32","GetOpenFileNameA"
Def @GetFileTitle(3) !"COMDLG32.DLL", "GetFileTitleA"

Proc QFileDialog
  Parameters Opc$,Own&,Fil$,Headl$,Liste&
  Declare X%,Pfad$,FileTitle$,Retrn$
  Dim Ofn#,76
  Dim Filter#,256
  Dim File#,1024
  Clear ofn#
  Clear Filter#

  String Filter#,0 = Fil$  ' Dateifilter. Ersetze alle | mit $0
  WhileLoop (@Len(Fil$) + 1)
    If @Byte(Filter#,(&Loop - 1)) = 124
      Byte Filter#,(&Loop - 1) = 0
    EndIf
  EndWhile

  Long Ofn#,0  = 76            ' lStructSize
  Long Ofn#,4  = Own&         ' hwndOwner
  Long Ofn#,8  = %HInstance    ' hInstance
  Long Ofn#,12 = Filter#       ' lpstrFilter
  Long Ofn#,28 = File#         ' lpstrFile
  Long Ofn#,32 = 1024          ' nMaxFile
  Long Ofn#,40 = 100           ' nMaxFileTitle
  Long Ofn#,48 = addr(Headl$)  ' lpstrTitle
'  Long Ofn#,52 = $181A0C       ' Flags 

' Prozedur Load File fr Input
  Proc QLFile
    Declare Rc%
    Long Ofn#,52 = $181A0C       ' Flags Multi Select
    Rc% = 1
    GetOpen(ofn#)
    Clear Filter#
    Pfad$ = @String$(File#,0)
    X% = (@Len(Pfad$) + 1)

    If @Byte(File#,X%) ' prfe 2. Stelle hinter dem Namen
      ' es ist nicht $0 somit ist nur der Pfad in Pfad$ und es folgen die Dateinamen
      While 1
        FileTitle$ = @String$(File#,X%)
        If @Len(FileTitle$)
          @AddString(Liste&,Pfad$+"\"+FileTitle$)
          Add X%,@Len(FileTitle$)
          Inc X%
        Else
          Break
        EndIf
      EndWhile
    Else    ' es wurde nur eine Datei gewhlt und Pfad$ enthlt Pfad und Name der Datei
      If (@String$(File#,0) = "")   ' es wurde abgebrochen
        Rc% = -1
      Else
        @AddString(Liste&,@String$(File#,0))
      EndIf
    EndIf
    Return Rc%
  EndProc

  ' Prozedur Save File (beide Varianten: ohne (Save) Meldung, mit (Save1) Meldung wenn Datei existiert.
  Proc QSFile
    Parameters N%
    Declare Fnm$,Rc%,T0&,T1&,T2&,T3&,T4&,R1&,R2&,R3&,B1&,DLG&,Fnt&
    Long Ofn#,52 = $18180C       ' Flags Single Select
    GetSave(ofn#)
    Fnm$ = @String$(File#,0)
    Case (Fnm$ = "") : Return -1    
    @AddString(Liste&,@String$(File#,0))    
    IfNot @FileExists(Fnm$)
      Rc% = 0
    Else
      Rc% = 1
      If N%       ' soll eine Meldung erfolgen? (Save1)
        WindowStyle 84
        DLG& = CREATE("WINDOW",%Hwnd,"Achtung",((%MaxX / 2) - 275),((%MaxY / 2) - 95),550,190)
        Fnt& = @Create("Font","MS Sans Serif",17,0,0,0,0)
        T0& =@CREATE("TEXT",DLG&,Fnm$,010,0005,0520,0035)

        T1& =@CREATE("TEXT",DLG&,"Die Datei existiert bereists",0130,0035,0179,0024)
        T2& =@CREATE("TEXT",DLG&,"Sollen die neuen Daten die alten Daten ersetzen?",0110,0060,0300,0023)
        T3& =@CREATE("TEXT",DLG&,"Sollen die neuen Daten zu den bestehenden hinzugefgt werden?",0016,0080,0390,0023)
        T4& =@CREATE("TEXT",DLG&,"Soll abgebrochen werden?",0241,0100,0170,0023)
        R1& =@CREATE("RADIOBUTTON",DLG&,"",0412,0059,0020,0020)
        R2& =@CREATE("RADIOBUTTON",DLG&,"",0412,0079,0020,0020)
        R3& =@CREATE("RADIOBUTTON",DLG&,"",0412,0099,0020,0020)
        B1& =@CREATE("BUTTON",DLG&,"O.K.",0230,0130,0070,0030)    
        SetFont T0&,Fnt&
        SetFont T1&,Fnt&
        SetFont T2&,Fnt&
        SetFont T3&,Fnt&
        SetFont T4&,Fnt&
        SetFont B1&,Fnt&
        SetCheck R3&,1
        WhileNot @GetFocus(B1&)
          WaitInput
          If @GetCheck(R1&)
            Rc% = 2
          ElseIf @GetCheck(R2&)
            Rc% = 3  
          ElseIf @GetCheck(R3&)
            Rc% = 4
          EndIf
        EndWhile  
        DeleteObject Fnt&
        @DestroyWindow(DLG&)  
      EndIf
    EndIf
    Return Rc%
  EndProc

  If (@Lower$(Opc$) = "load")
    QLFile
    QRet% = @%(0)
  ElseIf (@Lower$(Opc$) = "save")
    QSFile 0
    QRet% = @%(0)
  ElseIf (@Lower$(Opc$) = "save1")
    QSFile 1
    QRet% = @%(0)
  EndIf

  Dispose Ofn#
  Dispose Filter#
  Dispose File#
  Return QRet%
EndProc